package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.object.TokenData;
import com.yice.common.core.upload.BaseUpDownloader;
import com.yice.common.core.upload.UpDownloaderFactory;
import com.yice.common.core.upload.UploadResponseInfo;
import com.yice.common.core.upload.UploadStoreTypeEnum;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.minio.config.MinioProperties;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.constant.DatasetConstant;
import com.yice.webadmin.app.dao.DatasetOutputMapper;
import com.yice.webadmin.app.model.DatasetOutput;
import com.yice.webadmin.app.service.DatasetOutputService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.List;

/**
 * 数据集详情数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("datasetOutputService")
public class DatasetOutputServiceImpl extends BaseService<DatasetOutput, Long> implements DatasetOutputService {

    @Autowired
    private DatasetOutputMapper datasetOutputMapper;
    @Autowired
    private IdGeneratorWrapper idGenerator;
    @Autowired
    private UpDownloaderFactory upDownloaderFactory;
    @Autowired
    private MinioProperties minioProperties;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<DatasetOutput> mapper() {
        return datasetOutputMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param datasetOutput 新增对象。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public DatasetOutput saveNew(DatasetOutput datasetOutput) {
        datasetOutputMapper.insert(this.buildDefaultValue(datasetOutput));
        return datasetOutput;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param datasetOutputList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<DatasetOutput> datasetOutputList) {
        if (CollUtil.isNotEmpty(datasetOutputList)) {
            datasetOutputList.forEach(this::buildDefaultValue);
            datasetOutputMapper.insertList(datasetOutputList);
        }
    }

    /**
     * 记录地址并保存到minio中。
     * @param fileType 文件类型。
     * @param fileUrl 文件地址。
     * @param versionId 版本标识。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public DatasetOutput saveNew(String fileType, String fileUrl, Long versionId) {
        DatasetOutput datasetOutput = new DatasetOutput();
        String uploadUrl = doUpload(fileUrl,fileType,datasetOutput);
        if(StringUtils.isEmpty(uploadUrl)) return null;

        datasetOutput.setOutputId(idGenerator.nextLongId());
        datasetOutput.setCreateUserId(TokenData.takeFromRequest().getUserId());
        datasetOutput.setVersionId(versionId);
        datasetOutput.setOutputStartTime(new Date());
        datasetOutput.setStatus(DatasetConstant.STATUS_UNFINISHED);
        datasetOutput.setDownloadUrl(uploadUrl);
        datasetOutput.setMarkFormatType(fileType);
        datasetOutput.setOutputPostion(DatasetConstant.OUTPUT_POSTION);
        datasetOutput.setOutputContent(DatasetConstant.OUTPUT_CONTENT);
        datasetOutputMapper.insert(datasetOutput);
        return datasetOutput;
    }

    /**
     * 根据类型，生成对应的文件类型名称
     * @param fileUrl 文件地址
     * @param fileType 文件类型
     */
    private String doUpload(String fileUrl, String fileType, DatasetOutput datasetOutput) {
        String fileName = null;
        try {
            Path file = Paths.get(fileUrl);
            Resource resource = new UrlResource(file.toUri());
            byte[] data = IOUtils.toByteArray(resource.getInputStream());
            datasetOutput.setDataCount(Long.valueOf(JSON.parseArray(new String(data, StandardCharsets.UTF_8)).size()));
            double sizeInMb = (double) resource.contentLength() / 1024;
            DecimalFormat df = new DecimalFormat("#.##");
            datasetOutput.setFileSize(df.format(sizeInMb) + DatasetConstant.KB);
            UploadStoreTypeEnum uploadStoreType = UploadStoreTypeEnum.values()[DatasetConstant.UPLOAD];
            BaseUpDownloader upDownloader = upDownloaderFactory.get(uploadStoreType);
            UploadResponseInfo responseInfo = upDownloader.doUpload(resource.getInputStream(),
                    DatasetConstant.FILE_NAME + fileType);
            if (!Boolean.TRUE.equals(responseInfo.getUploadFailed())) {
                fileName = buildDownloadUrl(responseInfo.getFilename());
            }
        }catch (IOException ex){
            log.error("上传文件错误信息为:", ex);
        }
        return fileName;
    }

    /**
     * 构建文件下载链接
     * @param fileUrl
     * @return
     */
    private String buildDownloadUrl(String fileUrl) {
        StringBuilder sb = new StringBuilder();
        sb.append(minioProperties.getEndpoint()).
                append("/").append(minioProperties.getBucketName()).
                append("/").append(fileUrl);
        return sb.toString();
    }

    /**
     * 更新数据对象。
     *
     * @param datasetOutput         更新的对象。
     * @param originalDatasetOutput 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(DatasetOutput datasetOutput, DatasetOutput originalDatasetOutput) {
        MyModelUtil.fillCommonsForUpdate(datasetOutput, originalDatasetOutput);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<DatasetOutput> uw = this.createUpdateQueryForNullValue(datasetOutput, datasetOutput.getOutputId());
        return datasetOutputMapper.update(datasetOutput, uw) == 1;
    }

    /**
     * 删除指定数据。
     *
     * @param outputId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long outputId) {
        return datasetOutputMapper.deleteById(outputId) == 1;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getDatasetOutputListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<DatasetOutput> getDatasetOutputList(DatasetOutput filter, String orderBy) {
        return datasetOutputMapper.getDatasetOutputList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getDatasetOutputList)，以便获取更好的查询性能。
     *
     * @param filter  主表过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<DatasetOutput> getDatasetOutputListWithRelation(DatasetOutput filter, String orderBy) {
        List<DatasetOutput> resultList = datasetOutputMapper.getDatasetOutputList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    private DatasetOutput buildDefaultValue(DatasetOutput datasetOutput) {
        if (datasetOutput.getOutputId() == null) {
            datasetOutput.setOutputId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(datasetOutput);
        return datasetOutput;
    }
}
